//
//  token.h
//  Lily
//
//  Created by KMY on 2015/05/08.
//  Copyright (c) 2015年 KMY. All rights reserved.
//

#ifndef __Lily__token__
#define __Lily__token__

#include <stdio.h>
#include "character.h"
#define _TABLEN 4				// タブの大きさ

class Script;

class Token {
public:
	enum TokenType {
		TOKEN_UNKNOWN,			// 解析前の語句（変数名をリストから探す前とか）
		TOKEN_YN,				// 改行文字
		TOKEN_ENDFILE,			// ファイルの終端
		TOKEN_ENDINST,			// 命令の終わり（ ; などの命令間区切り。ない場合あり）
		TOKEN_ENDPUNC,			// 命令の区切り（、）
		TOKEN_VAR,				// 変数
		TOKEN_CONST,			// 定数
		TOKEN_NUM,				// 数値リテラル
		TOKEN_STR,				// 変数展開する文字列リテラル（PHPのダブルクォートみたいな）
		TOKEN_STATICSTR,		// 変数展開などしない文字列リテラル（PHPのシングルクォートみたいな）
		TOKEN_INST,				// 関数＆メソッド
		TOKEN_FUNC,				// 関数
		TOKEN_METHOD,			// メソッド
		TOKEN_JOSHI,			// 助詞　中身には助詞の種類を表す数値が入る
		TOKEN_SPACE,			// 空白
		TOKEN_INDENT,			// 空白（インデント）　中身には空白の文字数が入る
		TOKEN_SYMBOL,			// 記号、演算子
		TOKEN_JAVA_SRC,			// Javaのソース部分
		TOKEN_JAVA_PARAM,		// Javaの引数部分
		TOKEN_S_FUNCTION,		// 関数宣言の前につける記号
		TOKEN_S_MACRO,			// マクロ宣言の前につける記号
	};
	enum JoshiType {
		JOSHI_UNDEF,
		JOSHI_TO,
		JOSHI_HA,
		JOSHI_TOHA,
		JOSHI_WO,
		JOSHI_D_NA,				// Dのついているものは助詞検出補助のためのもので助詞ではない
		JOSHI_NARA,
		JOSHI_NARABA,
	};
	enum SymbolType {
		SYMBOL_DAINARI,			// <
		SYMBOL_SYOUNARI,		// >
		SYMBOL_QUES,			// ?
		SYMBOL_JAVA_START,		// <?
		SYMBOL_JAVA_END,		// ?>
		SYMBOL_MKAKKOS,			// (
		SYMBOL_MKAKKOE,			// )
	};
public:
	Token(Script* script);
	~Token();
	void analysis();
	const lchar* getTokenLchar();
	static const lchar* nextToken(const lchar* p);
	static void tokenTest(const lchar* p);
	static void tokenTestAll(const lchar* p);
private:
	Script* scriptObj;
	lchar* tokenLchar;
};

#endif /* defined(__Lily__token__) */
